from flask import Flask
from rotasCliente import rotasCliente
from flask import request
from flask import jsonify
import math
 

app = Flask("Minha API")

app.register_blueprint(rotasCliente)

@app.route('/retangulos/areas/<int:largura>/<int:altura>',methods=['GET'])
def retangulos_areas(largura,altura):

    caluloArea= largura*altura
    jsonResposta = jsonify(
        area=caluloArea
    )
    return jsonResposta ,200


@app.route('/retangulos/perimetros/<int:largura>/<int:altura>',methods=['GET'])
def retangulos_perimetros(largura,altura):
    caluloPerimetro= 2* largura+ 2*altura
    jsonResposta = jsonify(
        perimetro=caluloPerimetro
    )
    return jsonResposta ,200

@app.route('/retangulos/diagonais/<int:largura>/<int:altura>',methods=['GET'])
def retangulos_diagonais(largura,altura):

    caluloDiagonal= math.sqrt(largura*largura + altura*altura)
    jsonResposta = jsonify(
        diagonal=caluloDiagonal
    )
    return jsonResposta ,200
