from flask import Blueprint
from mysql import connector
from flask import jsonify
from flask import json
from flask import request
#configura o "alfabeto" do json para trabalho com UTF8
json.provider.DefaultJSONProvider.ensure_ascii = False

#configura objeto para tratar as rotas do cliente.
rotasCliente = Blueprint('API', "Cliente")

#cria uma conexao com o banco de dados
conexao = connector.connect(
  host="localhost",         #endereço do banco
  user="root",              #usuario
  password="",              #senha
  database="aulaPHPmysql",  #banco para conectar        
  charset='utf8'            #'alfabeto'
)



@rotasCliente.route('/clientes',methods=['POST'])
def clientes_POST():
    dados = request.json
    cursor = conexao.cursor(prepared=True)
    sql = """ insert into Cliente (nome, email,senha,nascimento,salario)
              values (%s,%s,%s,%s,%s); """
    novaTupla = (dados['nome'], dados['email'], dados['senha'], dados['nascimento'],dados['salario'])
    cursor.execute(sql, novaTupla)
    conexao.commit()
    idNovo = cursor.lastrowid
    cursor.close()
    jsonResposta = jsonify(
        idCliente=idNovo,
        nome = dados['nome'],
        email= dados['email'],
        nascimento= dados['nascimento'],
        salario = dados['salario']     
    )
    return jsonResposta

@rotasCliente.route('/clientes',methods=['GET'])
def clientes_GET():
    cursor = conexao.cursor()
    cursor.execute("""SELECT idCliente,nome,email,DATE_FORMAT(nascimento,'%d/%m/%Y'), 
                    salario from Cliente order by nome""");
    result = cursor.fetchall()
    cursor.close()
    conexao.commit()
    return jsonify(result)

@rotasCliente.route('/clientes/<int:idCliente>',methods=['GET'])
def clientes_GET_idCliente(idCliente):
 
    cursor = conexao.cursor(prepared=True)

    sql = """SELECT idCliente,
                    nome,
                    email,
                    DATE_FORMAT(nascimento,'%d/%m/%Y'), 
                    salario 
                    from Cliente where idCliente=%s order by nome"""

    selectTupla = (idCliente,)
    cursor.execute(sql, selectTupla)

    result = cursor.fetchall()
    cursor.close()
    conexao.commit()

    jsonResposta = jsonify(
       result     
    )
    return jsonResposta

@rotasCliente.route('/clientes/<int:idCliente>',methods=['PUT'])
def clientes_PUT(idCliente):
    dados = request.json
    cursor = conexao.cursor(prepared=True)
    sql = """ update cliente
                set nome=%s,
                email=%s,
                senha=%s,
                salario=%s,
                nascimento=%s
                where idCliente = %s """
    atualizarTupla = (dados['nome'], dados['email'], dados['senha'], dados['salario'],dados['nascimento'],idCliente)
    cursor.execute(sql, atualizarTupla)
    conexao.commit()
    cursor.close()
    jsonResposta = jsonify(
        idCliente=idCliente,
        nome = dados['nome'],
        email= dados['email'],
        nascimento= dados['nascimento'],
        salario = dados['salario']     
    )
    return jsonResposta


@rotasCliente.route('/clientes/<int:idCliente>',methods=['DELETE'])
def clientes_DELETE(idCliente):
    dados = request.json
    cursor = conexao.cursor(prepared=True)
    sql = "delete from cliente where idcliente=%s"
    excluirTupla = (idCliente,)
    cursor.execute(sql, excluirTupla)
    conexao.commit()
    cursor.close()

    jsonResposta = jsonify(
        status='ok',
        msg='Excluído com sucesso!'
        
    )
    return jsonResposta